<template>
	<div style="height:100%;">
		<div class="searchForm-header">
			<el-row>
				<el-form :model="query" label-width="100px" inline="">
					<el-row>
						<el-form-item label="库房名称" style="margin-left: -15px">
							<el-select v-model="query.wareName" size="small" clearable style="width:120px;margin-left: -8px" @change="changeWare">
								<el-option v-for="item in optionsWare" :key="item.id" :label="item.name" :value="item.name">
								</el-option>
							</el-select>
						</el-form-item>
						<el-form-item label="垛位名称" style="margin-left: -35px">
							<el-input v-model="query.stackName" size="small" style="width:120px;margin-left: -8px"></el-input>
						</el-form-item>
						<el-form-item label="物料名称" style="margin-left: -35px">
							<el-input v-model="query.materialName" size="small" style="width:120px;margin-left: -8px">
								<el-button slot="append" icon="el-icon-search" @click="showMaterial"></el-button>
							</el-input>
						</el-form-item>
						<el-form-item label="钢种" style="margin-left: -35px">
							<el-input v-model="query.standard" size="small" style="width:150px;margin-left: -8px">
								<el-button slot="append" icon="el-icon-search" @click="showMaterial"></el-button>
							</el-input>
						</el-form-item>
						<el-form-item label="客户名称" style="margin-left: -35px">
							<el-input v-model="query.customerName" size="small" style="width:170px;margin-left: -8px">
								<el-button slot="append"  icon="el-icon-search" @click="showCustomer"></el-button>
							</el-input>
						</el-form-item>
					</el-row>
					<el-row>
						<el-form-item label="规格型号" style="margin-left: -15px;margin-top: -15px">
							<el-input v-model="query.model" size="small" style="width:120px;margin-left: -8px">
							</el-input>
						</el-form-item>
						<el-form-item label="钢板号" style="margin-left: -35px;margin-top: -15px">
							<el-input v-model="query.plateNo" size="small" style="width:120px;margin-left: -8px">
							</el-input>
						</el-form-item>
						<el-form-item label="时间" style="margin-left: -35px;margin-top: -15px">
								<el-date-picker style="width: 330px" v-model="query.RecordDate" type="datetimerange" range-separator="至" start-placeholder="开始日期" size="small" end-placeholder="结束日期">
							    </el-date-picker>
						</el-form-item>
						<el-form-item label=" "  style="margin-top: -15px">
							<el-button @click="handleSearch" size="small" type="primary">查询</el-button>
							<el-button @click="handleDeficitCancel" size="small" type="danger">取消盘亏</el-button>
						</el-form-item>
					</el-row>
				</el-form>
			</el-row>
			<total-block style="margin-top: -25px;margin-left: -40px" ref="totalBlock" v-bind:childParam="childParam" v-bind:childUrl = 'childUrl'></total-block>
		</div>
		<div class="tabledata-grid">
			<el-table  v-loading="loading" :data="tableData" height="100%" stripe border style="width: 97%;" ref="multipleTable" @select="handleTableSelect"
			 :header-cell-style="{'text-align':'center'}">
				<el-table-column type="selection" width="40" header-align="center" align="center"></el-table-column>
				<el-table-column prop="wareName" label="仓库名称" width="100px" show-overflow-tooltip header-align="center">
				</el-table-column>
				<el-table-column prop="stackName" label="垛位" width="60px" show-overflow-tooltip header-align="center" align="center">
				</el-table-column>
				<el-table-column prop="layer" label="层号" show-overflow-tooltip width="60px" header-align="center" align="center">
				</el-table-column>
				<el-table-column prop="materialName" label="品名" show-overflow-tooltip width="60px" header-align="center" align="center">
				</el-table-column>
				<el-table-column prop="model" label="规格型号" show-overflow-tooltip width="180px" align="center">
				</el-table-column>
				<el-table-column prop="standard" label="钢种" show-overflow-tooltip width="80px" align="center">
				</el-table-column>
				<el-table-column prop="count" label="数量" width="80px" show-overflow-tooltip align="right">
				</el-table-column>
				<el-table-column prop="weight" label="重量" width="80px" show-overflow-tooltip align="right">
				</el-table-column>
				<el-table-column prop="plateNo" label="钢板号" width="200px" show-overflow-tooltip align="center">
				</el-table-column>
				<el-table-column prop="recordType" label="类型" width="100px" show-overflow-tooltip align="center" :formatter="typeFormatter">
				</el-table-column>
				<el-table-column prop="customerName" label="客户名称" show-overflow-tooltip width="300px">
				</el-table-column>
				<el-table-column prop="receiveAddress" label="收货地址" width="300" show-overflow-tooltip align="left">
				</el-table-column>
				<el-table-column prop="wgtDcnMtcCd" label="计量方式" width="100" show-overflow-tooltip header-align="center">
				</el-table-column>
				<el-table-column prop="edgeTy" label="切边类型" width="100" show-overflow-tooltip header-align="center">
				</el-table-column>
				<el-table-column prop="productionPlace" label="产地" width="250" show-overflow-tooltip header-align="center">
				</el-table-column>
				<el-table-column prop="remark" label="备注" width="100px" show-overflow-tooltip align="left">
				</el-table-column>
				<el-table-column prop="addUser.userDesc" label="操作人" width="150px" show-overflow-tooltip align="left">
				</el-table-column>
				<el-table-column prop="addTime" label="操作时间" width="200px" show-overflow-tooltip align="left">
				</el-table-column>
				<el-table-column prop="reason" label="盘亏原因" width="200px" show-overflow-tooltip align="left">
				</el-table-column>
				
				<el-table-column prop="backFlag" label="盘亏原因" width="200px" show-overflow-tooltip align="left">
				</el-table-column>
			 
				
				 
			</el-table>
			<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="currentPage"
			 :page-sizes="pageSizes" :page-size="pageSize" layout="total, sizes, prev, pager, next, jumper" :total="totalRows">
			</el-pagination>
		</div>


		<popup-stack-with-deficit-cancel-reason :wares="optionsWare" ref="PopupStackWithSelectWare" @receviceFromChild="receviceFromWareStack"></popup-stack-with-deficit-cancel-reason>

	</div>
</template>

<script>
	import axios from '@/axios'
	//import PopupStack from '@/components/PopupStack.vue'
	import PopupMaterial from '@/components/PopupMaterial.vue'
	import PopupCustomer from '@/components/PopupCustomer.vue'
	import PopupStackWithDeficitCancelReason from '@/components/PopupStackWithDeficitCancelReason.vue'
	import TotalBlock    from '@/components/TotalBlock.vue'
	export default {
		components: {
			PopupStackWithDeficitCancelReason,
			PopupMaterial,
			PopupCustomer,
			TotalBlock
		},
		data() {
			return {
				query: {
					wareName: '',
					stackName: '',
					model: '',
					materialName: '',
					standard: '',
					customerName: '',
					plateNo: '',
					RecordDate:[],
				},
				tableData: [],
				currentPage: 1,
				totalRows: 0,
				pageSizes: [50, 100, 200,500],
				pageSize: 50,
				HideAndShow: 0,
				optionsWare: [],
				dialogVisible: false,
				selectRows: [],
				moveFromStack: null,
				childUrl:'WareDeficitRecord/queryTotal.do',
				loading: false,
			};
		},
		//页面加载完成渲染
		mounted() {
			this.getWare()
			this.getTableData()
		},
		methods: {
			typeFormatter: function(row, column) {
				switch (row.recordType) {
					case "0":
						return "取消盘亏";
						break;
					default:
						return "盘亏";
						break;
				}
			},
			getWare() {
				var url = 'MaintWare/queryByUserId.do'
				var param = {}
				axios.get(url, param).then(response => {
					console.log(response)
					this.optionsWare = response.data.data
					if (response.data.data.length == 1) {
						this.wareName = response.data.data[0].name
						//	this.getStack()
					}
				});
			},

			// 修改每页行数
			handleSizeChange(val) {
				this.pageSize = val
				this.getTableData()
			},
			// 修改当前页事件
			handleCurrentChange(val) {
				this.currentPage = val
				this.getTableData()
			},
			//点击查询
			handleSearch() {
				this.currentPage = 1
				this.getTableData()
			},
			showMaterial() {
				this.$refs.PopupMaterial.show()
			},
			receviceFromMaterial(material) {
				this.query.materialName = material.name
				this.query.standard = material.standard
			},
			showCustomer() {
				this.$refs.PopupCustomer.show()
			},
			receviceFromCustomer(customer) {
				this.query.customerName = customer.name
			},
			getTableData() {
				var url = 'WareDeficitRecord/query.do'
				if(this.query.RecordDate == null){
					this.query.RecordDate = [false,false];
				}
				this.loading = true
				var param = {
					page: this.currentPage,
					rows: this.pageSize,
					wareName: this.query.wareName,
					stackName: this.query.stackName,
					model: this.query.model,
					materialName: this.query.materialName,
					standard: this.query.standard,
					customerName: this.query.customerName,
					plateNo: this.query.plateNo,
					pFromDate:(!this.query.RecordDate[0]) ? "1970-01-01 00:00:00" : this.query.RecordDate[0].Format("yyyy-MM-dd HH:mm:ss"),		//date类型
					pToDate  :(!this.query.RecordDate[1]) ? new Date().Format("yyyy-MM-dd HH:mm:ss") :this.query.RecordDate[1].Format("yyyy-MM-dd HH:mm:ss"),

				}
				this.childParam = param;
				axios.get(url, param).then(response => {
					if (response.data.code == 0) {
						this.tableData = response.data.data.list
						this.totalRows = response.data.data.total
						this.$refs.totalBlock.getTotalData();
					} else {
						this.$message({
							type: 'error',
							message: '操作失败；' + response.data.msg,
						});
					}
					this.loading = false;
				});
			},
			handleTableSelectionChange(val) {
				this.selectRows = val
			},
			 
			receviceFromWareStack(stack, layer, reason) {
				var url = 'WareDeficit/cancel.do'
				var param = {
					json: JSON.stringify(this.selectRows),
					reason: reason,
					toStack: JSON.stringify(stack),
					layer: layer
				}
				axios.post(url, param).then(response => {
					if (response.data.code == 0) {
						this.getTableData()
					} else {
						this.$message({
							type: 'error',
							message: '操作失败；' + response.data.msg,
						});
					}
				});

			},

			handleTableSelect(selection, row) {
				if (row.recordType == '0') {
					this.$message({
						type: 'error',
						message: '取消记录无法取消盘亏',
					});
					this.$refs.multipleTable.toggleRowSelection(row, false);
				} else {
					this.selectRows = selection

				}
			},
			handleDeficitCancel() {
					if (this.selectRows.length < 1) {
					this.$message({
						type: 'error',
						message: '至少选择一条数据取消盘亏！',
					});
					return
				}
				for (var i = 0; i < this.selectRows.length; i++) {
					if(this.selectRows[i].recordType =='0'){
						this.$message({
							type: 'error',
							message: '取消记录不能再次取消出库！',
						});
						return
					}
					
					if(this.selectRows[i].backFlag =='1'){
						this.$message({
							type: 'error',
							message: '该记录不能再次取消出库！',
						});
						return
					}
				}
			 
				this.$refs.PopupStackWithSelectWare.show()
			},
			changeWare(){
				this.currentPage = 1
				this.getTableData()
			}
		},
	}
</script>

<style>
.searchForm-header{
		/*background-color: red;*/
		height: auto;
		/*;*/
		margin-left: 10px;
	}
	.tabledata-grid{
		/*margin-left: 100px;*/
		font-size: 20px;
		height: calc(100% - 200px);
		/*background-color: #000;*/
	}
</style>
